import Robot
import World
import System

clr :: String
clr =  "\\033[2J"

goto :: Pos -> String
goto (x,y) =  "\\033[" ++ show y ++ ";" ++ show x ++ "H"

drawBord :: World->String
drawBord world = foldr (++) "" [goto (0,y)++"*"++goto (w+2,y)++"*"|y<-[0..h+2]]++goto (1,0)++['*'|x<-[1..w+2]]++goto (1,h+2)++['*'|x<-[1..w+2]]
    where
      w=(width world)
      h=(height world)

shift::Pos->Pos
shift (x,y) = (x+1,y+1)

display world = system ("echo -e "++"'"++str++"\n'")
    where
      str=clr++(goto (shift (start world)))++"S"++(goto (shift (goal world)))++"G"++(foldr (++) "" (map (\(x,y)->(goto (shift (x,y))++"M")) (walls world)))++(drawBord world)

drawRobot pos = system ("echo -e "++"'"++(goto (shift pos))++"R\n'")

animate world commande = animate' world (start world) commande
    where animate' world pos [] = do 
            display world
            drawRobot pos
            system ("echo -e '"++(goto (shift ((width world),(height world))))++"'")
            putStrLn ("\nAnimation is done")
          animate' world pos (s:ss) = do 
            display world
            drawRobot pos
            system ("echo -e '"++(goto (shift ((width world),(height world))))++"'")
            system ("sleep 1")
            animate' world (update pos s) ss 

main = do
  display world
  let sol=(findTraject world)
  animate world sol
  putStr ("Sulution = "++sol++"\n")
