module Robot where
import World

data Traject = Traject{com::String,pos::Pos}

isCorrect::World->Traject->Bool
isCorrect world traject =
    x>0 && x<w+1 && y>0 && y<h+1 && not (elem (x,y) wa)
    where (x,y)=(pos traject)
          wa=(walls world)
          w=(width world)
          h=(height world)

toTraject::String->Pos->Traject
toTraject command position = Traject{com=command,pos=position}

toPos::Traject->Pos
toPos t = (pos t)

correctMoves::World->Traject->[Traject]
correctMoves world t = filter (isCorrect world) [
                        (toTraject (c++"L") (x-1,y)),
                        (toTraject (c++"R") (x+1,y)),
                        (toTraject (c++"B") (x,y+1)),
                        (toTraject (c++"U") (x,y-1))
                       ]
    where (x,y)=(pos t)
          c=(com t)



















findTraject::World->String
findTraject world = findTraject' [(toTraject "" (start world))] [(start world)]
    where findTraject' [] _ = "There is no soultion"
          findTraject' (t:ts) histo 
              | (elem (pos t) (goals world)) = (com t)
              | otherwise = findTraject' (ts++succ) (histo++(map (toPos) succ))
              where succ=filter (\x->(not (elem (pos x) histo))) (correctMoves world t)

update::Pos->Char->Pos
update (x,y) 'L' = (x-1,y)
update (x,y) 'R' = (x+1,y)
update (x,y) 'U' = (x,y-1)
update (x,y) 'B' = (x,y+1)  


